
Name:          ucommon
Version:       7.0.0
Release:    1%{?dist}
Summary:       Portable C++ framework for threads and sockets

License:       LGPL-3.0-or-later
URL:           http://www.gnu.org/software/commoncpp
Source0:       https://ftpmirror.gnu.org/commoncpp/ucommon-%{version}.tar.gz

BuildRequires: cmake
BuildRequires: gcc-c++
BuildRequires: doxygen
BuildRequires: graphviz-gd
BuildRequires: make
BuildRequires: gnutls-devel


%description
GNU uCommon C++ is a lightweight library to facilitate using C++ design
patterns even for very deeply embedded applications, such as for systems using
uclibc along with POSIX threading support. For this reason, uCommon disables
language features that consume memory or introduce runtime overhead. UCommon
introduces some design patterns from Objective-C, such as reference counted
objects, memory pools, and smart pointers. UCommon introduces some new concepts
for handling of thread locking and synchronization.  Starting with release
5.0, GNU uCommon also bundles GNU Common C++ libraries.


%package bin
Summary:       GNU uCommon system and support applications
Requires:      %{name} = %{version}-%{release}

%description bin
This is a collection of command line tools that use various aspects of the
ucommon library. Some may be needed to prepare files or for development of
applications.


%package devel
Summary:       Headers for building GNU uCommon applications
Requires:      %{name} = %{version}-%{release}
Requires:      openssl-devel
Requires:      pkgconfig

%description devel
This package provides header and support files needed for building
applications that use the uCommon and commoncpp libraries.


%package doc
Summary: Generated class documentation for GNU uCommon

%description doc
Generated class documentation for GNU uCommon library from header files in
HTML format.


%prep
%setup -q


%build
export CXXFLAGS="-std=c++14 $RPM_OPT_FLAGS"
%cmake
%cmake_build
%cmake_build --target doc


%install
%cmake_install



%files
%doc AUTHORS README NEWS SUPPORT ChangeLog
%license COPYING COPYING.LESSER
%{_libdir}/libucommon.so.8*
%{_libdir}/libusecure.so.8*
%{_libdir}/libcommoncpp.so.8*

%files bin
%{_bindir}/args
%{_bindir}/mdsum
%{_bindir}/pdetach
%{_bindir}/sockaddr
%{_bindir}/zerofill
%{_bindir}/scrub-files
%{_bindir}/car
%{_bindir}/keywait
%{_bindir}/urlout
%{_mandir}/man1/args.*
%{_mandir}/man1/car.*
%{_mandir}/man1/mdsum.*
%{_mandir}/man1/pdetach.*
%{_mandir}/man1/scrub-files.*
%{_mandir}/man1/sockaddr.*
%{_mandir}/man1/zerofill.*
%{_mandir}/man1/keywait.*
%{_mandir}/man1/urlout.*

%files devel
%{_bindir}/ucommon-config
%{_bindir}/commoncpp-config
%{_datadir}/%{name}/
%{_includedir}/ucommon/
%{_includedir}/commoncpp/
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc
%{_mandir}/man1/ucommon-config.*
%{_mandir}/man1/commoncpp-config.*

%files doc
%doc %{_vpath_builddir}/doc/html/*


%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 7.0.0-1
- initial build
